//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright Â© 2004 -2009 Ronald D. Grindle
//---------------------------------------------------------
/*
 * Created on Jul 11, 2004
 *
 */
package com.qanavigation.Basics;

import java.security.MessageDigest;


/**
 * @author RDG
 *
 */
public class SFormatter extends SFormatterB {
	
	public static final String FIELD0 = "{0}";
	public static final String FIELD1 = "{1}";
	public static final String FIELD2 = "{2}";
	public static final String FIELD3 = "{3}";
	
	public static final int FLEN = 3;
	
	
	public static String byteArrayToHexString(byte in[]) {

	    byte ch = 0;

	    int i, x;
	    
	    String rslt = "";

	    String hChr[] = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"};
	    
	    x = in.length;

	    for( i = 0; i < x; ++i ) {

	        ch = (byte) (in[i] & 0xF0); // Strip off high nibble

	        ch = (byte) (ch >>> 4); // shift the bits down

	        ch = (byte) (ch & 0x0F); // must do this is high order bit is on!

	        rslt += hChr[ (int) ch]; // convert the nibble to a String Character

	        ch = (byte) (in[i] & 0x0F); // Strip off low nibble 

	        rslt += hChr[ (int) ch]; // convert the nibble to a String Character
	        
	        rslt += " ";
	    }

	    return rslt;
	}   	
	
	/** 
	 * Chop string to desired length
	 * @param p_Str
	 * @param p_Len
	 * @return
	 */
	public static String chop( String p_Str, int p_Len ) {
		
		String res;
		
		if( p_Str.length() > p_Len ) {
			
			res = p_Str.substring( 0, p_Len -1 );
		}
		else {
			
			res = p_Str;
		}
		
		return res;
	}
	
	/**
	 * Prepares string to hidden UTF8 
	 * @param p_Val
	 */
	public static String conv2HidUTF8( String p_Str ) {
			
		String str;
		
		try {
			
			str = new String( p_Str.getBytes("UTF-8") );
		}
		catch( Exception excp ) {
			
			str = "<error in conv2HidUTF8()>";
		}
		
		return str;
	}
	
	/**
	 * Prepares string to hidden UTF8 
	 * @param p_Val
	 * @param p_Coding
	 */
	public static String conv2HidUTF8( String p_Str, String p_Coding ) {
			
		String str;
		
		try {
			
			//str = new String( p_Str.getBytes("UTF-8"), "ISO-8859-1" );
			str = new String( p_Str.getBytes("UTF-8"), p_Coding );
		}
		catch( Exception excp ) {
			
			str = "<error in conv2HidUTF8()>";
		}
		
		return str;
	}
	
	/**
	 * Prepares string encoded in hidden UTF8 
	 * @param p_Val
	 * @param p_Coding
	 */
	public static RsltString conv2UTF8( RsltString p_Val, String p_Coding ) {
		
		RsltString rStr = new RsltString();
		String str;
		
		try {
			// "ISO-8859-1"	
			str = new String( p_Val.getString().getBytes( p_Coding ), "UTF-8" );

			rStr.setString( str );
		}
		catch( Exception excp ) {
			
			rStr.setRsltByExcp( excp );
		}
		
		return rStr;
	}
	
	/**
	 * Prepares string encoded in hidden UTF8
	 * @param p_Val
	 */
	public static String conv2UTF8( String p_Val ) {
		
		String str;
		
		try {
			
			str = new String( p_Val.getBytes( ),"UTF-8" );
		}
		catch( Exception excp ) {
		
			str = "";
		}
		
		return str;
	}
	
	/**
	 * Prepares string encoded in hidden UTF8
	 * @param p_Val
	 * @param p_Coding
	 */
	public static String conv2UTF8( String p_Val, String p_Coding ) {
		
		String str;
		
		try {
			
			str = new String( p_Val.getBytes( p_Coding ),"UTF-8" );
		}
		catch( Exception excp ) {
		
			str = "";
		}
		
		return str;
	}	
	

	
	/**
	 * Replaces quotes with "&#34;".
	 * @param p_Str
	 * @return
	 */
	public static String encode4InpHTML( String p_Str ) {

		return p_Str.replaceAll( "\"", "&#34;" );
	}


	/**
	 * Replaces special characters for an URL param list.
	 * @param p_Str
	 * @return
	 */
	public static String encodeURL( String p_Str ) {
		
		String res;
		
		res = p_Str;
		
		res = res.replaceAll( "%", "%25");
		res = res.replaceAll( "\\+", "%2B");		
		res = res.replace( ' ', '+' );		
		
		res = encodeISORest( res );

		return res;
	}
	
	public static String encodeISO( String p_Str ) {
		
		String res;
		
		res = p_Str;
		
		// RegEx special characters - + * ? ( ) [ ] \ | $ ^ !
		
		res = res.replaceAll( "%", "%25");
		
		res = res.replaceAll( " ", "%20");
		
		res = res.replaceAll( "\\+", "%2B");
		
		res = encodeISORest( res );

		return res;		
	}

	/**
	 * Provides a SHA digested String.
	 * @param p_Str
	 * @return
	 */
	public static String digestSHA( String p_Str ) {
		
		String res = "";
		
		try {

			byte[] raw; 
			
			raw = p_Str.getBytes();
			
			MessageDigest md = MessageDigest.getInstance( "SHA" );

			md.update( raw );
		
			byte[] dig = md.digest();
			
			res = hexEncode( dig );
		} 
		catch (Exception excp) {

		}
		
		return res;
	}
	
	
	/** Replaces '{0}' in the first string with the string provided with the 
	 *  following parameter.
	 * @param p_Str
	 * @param p_subStr
	 * @return The combined string.
	 */
	public static String format( String p_Str, String p_subStr ) {
		
		int x, n;
		
		String rStr = "";

		n = 0;		
		
		x = p_Str.indexOf( FIELD0 );
		
		while( -1 != x ) {
			
			rStr += p_Str.substring( n, x );
			
			rStr += p_subStr;
			
			n = x + FLEN;
			
			x = p_Str.indexOf( FIELD0, n );
		}
		
		rStr += p_Str.substring( n );
			
		return rStr;
	}
	
	/**Replaces '{0}' and '{1}' in the first string with the string provided with the 
	 *  following parameter.
	 * @param p_Str
	 * @param p_subStr0
	 * @param p_subStr1
	 * @return The combined string.
	 */
	public static String format( String p_Str, String p_subStr0, String p_subStr1 ) {
		
		int x, n;
		
		String rStr0 = "";
		String rStr1 = "";

		n = 0;		
		
		x = p_Str.indexOf( FIELD0 );
		
		while( -1 != x ) {
			
			rStr0 += p_Str.substring( n, x );
			
			rStr0 += p_subStr0;
			
			n = x + FLEN;
			
			x = p_Str.indexOf( FIELD0, n );
		}
		
		rStr0 += p_Str.substring( n );
		
		n = 0;		
		
		x = rStr0.indexOf( FIELD1 );
		
		while( -1 != x ) {
			
			rStr1 += rStr0.substring( n, x );
			
			rStr1 += p_subStr1;
			
			n = x + FLEN;
			
			x = rStr0.indexOf( FIELD1, n );
		}
		
		rStr1 += rStr0.substring( n );
			
		return rStr1;
	}
	
	/**
	 * 
	 * @param p_Str
	 * @param p_subStr0
	 * @param p_subStr1
	 * @param p_subStr2
	 * @return
	 */
	public static String format( String p_Str, String p_subStr0, String p_subStr1, String p_subStr2 ) {
		
		int x, n;
		
		String rStr0 = "";
		String rStr1 = "";
		String rStr2 = "";		

		n = 0;		
		
		x = p_Str.indexOf( FIELD0 );
		
		while( -1 != x ) {
			
			rStr0 += p_Str.substring( n, x );
			
			rStr0 += p_subStr0;
			
			n = x + FLEN;
			
			x = p_Str.indexOf( FIELD0, n );
		}
		
		rStr0 += p_Str.substring( n );
		
		n = 0;		
		
		x = rStr0.indexOf( FIELD1 );
		
		while( -1 != x ) {
			
			rStr1 += rStr0.substring( n, x );
			
			rStr1 += p_subStr1;
			
			n = x + FLEN;
			
			x = rStr0.indexOf( FIELD1, n );
		}
		
		rStr1 += rStr0.substring( n );
		
		n = 0;		
		
		x = rStr1.indexOf( FIELD2 );
		
		while( -1 != x ) {
			
			rStr2 += rStr1.substring( n, x );
			
			rStr2 += p_subStr2;
			
			n = x + FLEN;
			
			x = rStr1.indexOf( FIELD2, n );
		}
		
		rStr2 += rStr1.substring( n );
			
		return rStr2;		
	}
	
	public static String format( String p_Str, String p_subStr0, String p_subStr1, String p_subStr2, String p_subStr3 ) {
		
		int x, n;
		
		String rStr0 = "";
		String rStr1 = "";
		String rStr2 = "";
		String rStr3 = "";	

		n = 0;		
		
		x = p_Str.indexOf( FIELD0 );
		
		while( -1 != x ) {
			
			rStr0 += p_Str.substring( n, x );
			
			rStr0 += p_subStr0;
			
			n = x + FLEN;
			
			x = p_Str.indexOf( FIELD0, n );
		}
		
		rStr0 += p_Str.substring( n );
		
		n = 0;		
		
		x = rStr0.indexOf( FIELD1 );
		
		while( -1 != x ) {
			
			rStr1 += rStr0.substring( n, x );
			
			rStr1 += p_subStr1;
			
			n = x + FLEN;
			
			x = rStr0.indexOf( FIELD1, n );
		}
		
		rStr1 += rStr0.substring( n );
		
		n = 0;		
		
		x = rStr1.indexOf( FIELD2 );
		
		while( -1 != x ) {
			
			rStr2 += rStr1.substring( n, x );
			
			rStr2 += p_subStr2;
			
			n = x + FLEN;
			
			x = rStr1.indexOf( FIELD2, n );
		}
		
		rStr2 += rStr1.substring( n );
		
		n = 0;		
		
		x = rStr2.indexOf( FIELD3 );
		
		while( -1 != x ) {
			
			rStr3 += rStr2.substring( n, x );
			
			rStr3 += p_subStr3;
			
			n = x + FLEN;
			
			x = rStr2.indexOf( FIELD3, n );
		}
		
		rStr3 += rStr2.substring( n );
			
		return rStr3;		
	}
	
	/**
	 * Ripped from somewhere. Sad you have to do it by hand!
	 * @param aInput
	 * @return
	 */
	static private String hexEncode( byte[] aInput){
		
	   StringBuffer result = new StringBuffer();
	   
	   char[] digits = {'0', '1', '2', '3', '4','5','6','7','8','9','a','b','c','d','e','f'};
	   
	   for ( int idx = 0; idx < aInput.length; ++idx) {
	   	
			byte b = aInput[idx];
		 
			result.append( digits[ (b&0xf0) >> 4 ] );
			result.append( digits[ b&0x0f] );
	   }
	   
	   return result.toString();
	 }
		
}
