//---------------------------------------------------------
// RG Basic Tools Collection
// Copyright © 2003,2004 Ronald D. Grindle
//---------------------------------------------------------

package com.qanavigation.Basics;

import java.util.*;

/**
* A list for set functions.
* SetList isA ArrayList.
* Converts input arrays to a 1-dimensional.
*/
public class SetList extends RsltLst<String>
{

	static final long serialVersionUID = 61940017;
	
	// --------------------------------------------
	public SetList()
	{
	
		init();
	}

	// --------------------------------------------
	public SetList( Rslt2DArray p_2DArr ) {

		int i, x;

		init();
		
		if( p_2DArr.isOK() ) {

			x = p_2DArr.size();

			for( i = 0; i < x; ++i ) {

				add( p_2DArr.getCell( 0, i ) );
			}
		}
		
		setRsltStat( p_2DArr );
	}

	// --------------------------------------------
	public SetList( SetList p_sLst )
	{

		super( p_sLst );
		
		init();

		setRsltStat( p_sLst );
	}

	// --------------------------------------------
	public SetList( Collection<String> p_Coll )
	{

		super( p_Coll );
		
		//int x;
		
		init();

		//x = p_Coll.size();
	}

	// --------------------------------------------
	protected void init() {

		m_Result = new Rslt( this.getClass() );
	}

	/**
	* Can not override the indexed access of the original class for a different return type. 
	*/
	public String getString( int p_index ) {
	
		String val;

		val = (String)super.get( p_index );

		return val;			
	}
	
	public String set( int p_index, String p_Val  ){

		return super.set( p_index, p_Val );
	}
	
	// --------------------------------------------
	/* ????????????????
	public static implicit operator SetList( Rslt2DArray p_resT ) {

		SetList sLst = new SetList( p_resT );

		return sLst;
	}

*/

	// --------------------------------------------
	//public int Add( String p_val ) {
	public boolean add( String p_val ) {
	
		boolean b;
		
		b = super.add( p_val );

		setOK();

		return b;
	}	
	
	/**
	* Weeds out duplicates.
	*/
	public void distinct( ) {

		int i, x;
		Object anObj;
	
		sort();

		x = super.size() -1;

		for( i = 0; i < x; ++i ) {

			anObj = get(i);

			if( anObj.equals( get(i +1) ) ) {

				super.remove( i );
				x = super.size() -1;
				--i;
			}
		}
	}

	// ---------------------------
	protected boolean doSort() {
		
		boolean notSorted;
		String entry1;
		String entry2;
		int i, x;

		notSorted = false;

		x = size();
		
		if( x > 1 ) {

			entry1 = getString(0);
	
			for( i = 1; i < x; i++ ) {
	
				entry2 = getString(i);
	
				if( entry1.compareTo( entry2 ) > 0 ) {
	
					set( i-1, entry2 );
					set( i, entry1 );
	
					notSorted = true;
				}
				else {
					
					entry1 = entry2;	
				}					
			}
		}
	
		return notSorted;
	}	
	
	/**
	* Creates the intersected set of both lists.
	*/
	public void intersect( SetList p_aLst ) {

		int i, x, j, y, cmp;
		String myStr, theirStr;
//Comparer aComp = Comparer.DefaultInvariant;

		p_aLst.sort();

		sort();

		x = size();
		y = p_aLst.size();

		i = 0;
		j = 0;

		while( (i < x) && (j < y) ) {

			theirStr = p_aLst.getString( j );
			myStr = getString( i );
			
			cmp = myStr.compareTo( theirStr );

			if( cmp < 0 ) {
	
				remove( i );
				x = size();
			}
			else {

				if( cmp == 0 ) {
			
					++j;
					++i;
				}
				else {

					++j;
				}
			}
		}

		x = size();

		for( ; i < x;  ) {

			super.remove( i );

			x = size();
		}
	}

	/**
	* Joins the content of a list to this.
	*/
	public void join( SetList p_aLst ) {

		Iterator<String> it = p_aLst.iterator();
		
		String str;
		
		if(  it.hasNext() && ( isInStat( RsltStatVal.notInit ) || isOK( true ) ) ) {
				
			setOK();
		}

		while ( it.hasNext() ) {

			str = it.next();
			add( str );
		}
	}

	/**
	* Join &amp; distinct.
	*/
	public void merge( SetList p_aLst ) {

		join( p_aLst );
		distinct();
	}
	
	/**
	* Home made sort.
	*/
	public void sort() {
		
		boolean notSorted;

		notSorted = true;

		while( notSorted ) {

			notSorted = doSort( );
		}		
	}
	
}
