//---------------------------------------------------------
// RG SQL services
// Copyright © 2004 Ronald D. Grindle
//---------------------------------------------------------

package com.qanavigation.DBacc;

import com.qanavigation.Basics.*;

/**
* Don't get confused! 'Cols' are the columns to query for, 
* but in the table they are rows!
*/
public class QuerySet extends Rslt2DArray
{

	static final long serialVersionUID = 61940016;
	
	protected String m_TableName;
	protected boolean[] m_isKey;
	protected boolean[] m_isBlob;

	/**
	 * 
	 * @param i
	 * @return
	 */
	public String getQColName(int i) {

		return getCell( 0, i );
	}

	/**
	 * 
	 * @param i
	 * @return
	 */
	public String getQColVal( int i ) {

		return getCell( 1, i );
	}

	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean isBlob( int i ) {

		return m_isBlob[ i ];
	}
	
	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean isKey( int i ) {

		return m_isKey[ i ];
	}

	/**
	 * Add a value for a key column. (Only required for updates.)</p>
	 * <p>Forces an empty string to a NULL.
	 * @param p_Name
	 * @param p_Val
	 */
	public void addKeyCol( String p_Name, String p_Val, boolean p_isBlob ) {

		int i;
		String[] aRow = new String[2];

		aRow[0] = p_Name;
		
		if( p_Val.length() < 1 ) {
			
			aRow[1] = "NULL";
		}
		else {
			
			aRow[1] = p_Val;
		}

		i = this.size();

		add( aRow );
		
		m_isBlob[ i ] = p_isBlob;
		m_isKey[ i ] = true;
	}


	/**
	 * Add a value for a normal column.
	 * @param p_Name
	 * @param p_Val
	 */
	public void addQCol( String p_Name, String p_Val, boolean p_isBlob ) {

		int i;
		String[] aRow = new String[2];

		aRow[0] = p_Name;
		aRow[1] = p_Val;

		i = this.size();

		add( aRow );
		
		m_isBlob[ i ] = p_isBlob;
		m_isKey[ i ] = false;
	}


	/**
	 * 
	 * @param p_QCols The number of cols of the table row.
	 * @param p_TableName
	 */
	public QuerySet( int p_QCols, String p_TableName ) 
	{

		super( 2, p_QCols );
		
		m_isBlob = new boolean[ p_QCols ];
		
		m_isKey = new boolean[ p_QCols ];
		
		m_TableName = p_TableName;
		
		//m_colCount = 0;
	}
}
