//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2004 -2009 Ronald D. Grindle
//---------------------------------------------------------

package com.qanavigation.XMLBasics;

import com.qanavigation.Basics.Rslt;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.SourceLocator;
import javax.xml.transform.TransformerException;

// ###############################
public class TransfErrListener implements ErrorListener {
	
	Rslt m_Rslt;
	
	// -------------------------------------------
	public TransfErrListener( Rslt p_Rslt ) {

		m_Rslt = p_Rslt;
	}
	
	// -------------------------------------------
	public TransfErrListener( Rslt p_Rslt, String p_XSLTfile ) {

		m_Rslt = p_Rslt;
		
		String xsltFile = "XSLT file: '" + p_XSLTfile + "'";
		
		m_Rslt.addRsltAddInfo( xsltFile );		
	}

	// -------------------------------------------
	public void warning( TransformerException p_TExc)
							throws TransformerException {
	
		setRslt( p_TExc , "Warning: " );
	}

	// -------------------------------------------
	public void error( TransformerException p_TExc ) 
							throws TransformerException {

		setRslt( p_TExc , "Error: " );
		//String message = "Error: " + getExcInfo( p_TExc );
		//throw new TransformerException( message );
	}

	// -------------------------------------------
	public void fatalError( TransformerException p_TExc ) 
							throws TransformerException {
		
		setRslt( p_TExc , "Fatal Error: " );
	}

	// -------------------------------------------
	// return exception details
	private void setRslt( TransformerException p_TExc, String p_Lbl ) {

		String val;
		
		m_Rslt.addRsltAddInfo( p_Lbl );
		
		Throwable thr;
		
		thr = p_TExc.getException();
		
		if( null != thr ) {
			
			m_Rslt.setRsltByExcp( thr );
		}
		else {
			
			m_Rslt.setRsltByExcp( p_TExc );
		}
		
		val = p_TExc.getLocalizedMessage();
		
		if( null != val ) {
			
			m_Rslt.addRsltAddInfo( "Localized Message: " );
			m_Rslt.addRsltAddInfo( val );			
		}

		val = p_TExc.getLocationAsString();
		
		if( null != val ) {
			
			m_Rslt.addRsltAddInfo( "Location: " );
			m_Rslt.addRsltAddInfo( val );
		}
		
		SourceLocator loc = p_TExc.getLocator();
			
		if( null != loc ) {
			
			m_Rslt.addRsltAddInfo( "Locator: " );
			m_Rslt.addRsltAddInfo( loc.getPublicId() );
		}
	}
}
